/*
 * A basic extension of the java.awt.Frame class
 */

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.SystemColor;
import java.awt.TextField;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Vector;
import java.util.prefs.Preferences;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableModel;

public class MissionEditorFrame extends Frame implements ChangeListener
{
   private Mission mission;
   private Ship copiedship;
   private String lastfilename=null;

   private Frame me;
   private NavMapEditorCanvas naveditorcanvas;
   private JTabbedPane tabs;

   public void stateChanged(ChangeEvent env)
   {
	   // the slider changed
	   int value = slider.getValue();
	   Ship ship = mission.getCurrentNav().getCurrentShip();
	   if(ship != null)
	   {
		   ship.setRy((float) value);
		   missioncanvas.repaint();
	   }
   }
   
   public MissionEditorFrame()
   {
      me = this;
      copiedship = null;
      mission = new Mission();
      initComponents();

      fillChoice(shiptypechoice, getFromStream("ships.txt"));
      fillChoice(sectorchoice, getFromStream("sectors.txt"));
      fillChoice(commchoice, getFromStream("comms.txt"));
      fillChoice(videochoice, getFromStream("videos.txt"));
      commchoice.add("");
      videochoice.add("");
      source = null;
      updateNavPoint();

   }
   java.awt.Button shipscriptbutton;
   Button navscriptbutton;
   
   private void initComponents()
   {
      SymAction lSymAction = new SymAction();
      
      // This code is automatically generated by Visual Cafe when you add
      // components to the visual environment. It instantiates and initializes
      // the components. To modify the code, only use code syntax that matches
      // what Visual Cafe can generate, or Visual Cafe may be unable to back
      // parse your Java file into its visual environment.
      //{{INIT_CONTROLS
      setLayout(new BorderLayout(0, 0));
      //      setVisible(false);
      setSize(insets().left + insets().right + 560, insets().top
            + insets().bottom + 417);
      ///////////// bottom coordinates panel 
      java.awt.Panel coordinates_panel = new java.awt.Panel();
      coordinates_panel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      java.awt.Label statusbartext  = new Label("                               ");
      coordinates_panel.add(statusbartext);
      add("South", coordinates_panel);
      coordinates_panel.setBackground(SystemColor.control);

      // tabs
      tabs = new JTabbedPane();
      
      ///////////////
      Panel ship_and_properties_panel = new java.awt.Panel();
      ship_and_properties_panel.setLayout(new BorderLayout(0, 0));
      tabs.add("Ship and Nav editor", ship_and_properties_panel);
      
      
      ship_properties_panel_right = new java.awt.Panel();
      missionnametextfield = new TextField(10);      
      ship_properties_panel_right.setLayout(new GridLayout(18, 1, 0, 0));
      ship_properties_panel_right.setBounds(insets().left + 425, insets().top + 66, 135, 351);
      ship_properties_panel_right.setBackground(SystemColor.control);
      ship_and_properties_panel.add("East", ship_properties_panel_right);
      panel3 = new java.awt.Panel();
      panel3.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //    panel3.setBounds(0,0,135,39);
      ship_properties_panel_right.add(panel3);
      label2 = new java.awt.Label("ship");
      //      label2.setBounds(5,5,38,23);
      panel3.add(label2);
      shiptypechoice = new java.awt.Choice();
      //      shiptypechoice.setBounds(48,6,28,21);
      panel3.add(shiptypechoice);
      shiptypechoice.setEnabled(false);
      panel4 = new java.awt.Panel();
      panel4.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel4.setBounds(0,39,135,39);
      ship_properties_panel_right.add(panel4);
      label3 = new java.awt.Label("alignment");
      //      label3.setBounds(5,5,69,23);
      panel4.add(label3);
      Panel pilotpanel = new Panel();
      pilotpanel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      pilotpanel.add(new Label("Pilot Name"));
      pilotname = new java.awt.TextField(7);
      pilotname.setEnabled(false);
      pilotpanel.add(pilotname);
      ship_properties_panel_right.add(pilotpanel);
      
      // variable name panel
      Panel variablenamepanel = new Panel();
      variablenamepanel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      variablenamepanel.add(new Label("Name in scripts"));
      variablenametextbox = new java.awt.TextField(7);
      variablenametextbox.setEnabled(false);
      variablenamepanel.add(variablenametextbox);
      ship_properties_panel_right.add(variablenamepanel);
      
      
      //

      Panel commpanel = new Panel();
      commpanel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      commpanel.add(new Label("Comm"));
      commchoice = new Choice();

      Panel videopanel = new Panel();
      videopanel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      videopanel.add(new Label("Video"));
      videochoice = new Choice();

      commchoice.setEnabled(false);
      videochoice.setEnabled(false);
      commpanel.add(commchoice);
      videopanel.add(videochoice);
      ship_properties_panel_right.add(commpanel);
      ///////// don't need to edit videos now, done in comms
      ////////panel1.add(videopanel);
      alignmentchoice = new java.awt.Choice();
      alignmentchoice.addItem("friend");
      alignmentchoice.addItem("enemy");
      alignmentchoice.addItem("neutral");
      alignmentchoice.setBounds(79, 6, 28, 21);
      panel4.add(alignmentchoice);
      alignmentchoice.setEnabled(false);
      panel5 = new java.awt.Panel();
      panel5.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel5.setBounds(0,78,135,39);
      ship_properties_panel_right.add(panel5);
      label4 = new java.awt.Label("x");
      //      label4.setBounds(5,5,19,23);
      panel5.add(label4);
      xtext = new java.awt.TextField(7);
      //      xtext.setBounds(29,5,24,23);
      panel5.add(xtext);
      xtext.setEnabled(false);
      panel6 = new java.awt.Panel();
      panel6.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel6.setBounds(0,117,135,39);
      ship_properties_panel_right.add(panel6);
      label5 = new java.awt.Label("y");
      label5.setBounds(5, 5, 19, 23);
      panel6.add(label5);
      ytext = new java.awt.TextField(7);
      //      ytext.setBounds(29,5,24,23);
      panel6.add(ytext);
      ytext.setEnabled(false);
      panel7 = new java.awt.Panel();
      panel7.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel7.setBounds(0,156,135,39);
      ship_properties_panel_right.add(panel7);
      label6 = new java.awt.Label("z");
      //      label6.setBounds(5,5,19,23);
      panel7.add(label6);
      ztext = new java.awt.TextField(7);
      //      ztext.setBounds(29,5,24,23);
      panel7.add(ztext);
      ztext.setEnabled(false);
// ry slider
      Panel sliderpanel = new Panel();
      sliderpanel.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      sliderpanel.add(new Label("rY"));
      slider = new JSlider(0, 360, 0);
      slider.setToolTipText("Rotation about the y axis");
      slider.addChangeListener(this);
      Dimension size = slider.getPreferredSize();
      size.width /= 2;
      slider.setPreferredSize(size);
      sliderpanel.add(slider);
      ship_properties_panel_right.add(sliderpanel);
//      
      panel8 = new java.awt.Panel();
      panel8.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel8.setBounds(0,195,135,39);
      ship_properties_panel_right.add(panel8);
      
      
      playercheckbox = new java.awt.Checkbox("Player");
      playercheckbox.setBounds(5, 5, 64, 23);
      panel8.add(playercheckbox);
      playercheckbox.setEnabled(false);
      panel10 = new java.awt.Panel();
      panel10.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel10.setBounds(0,234,135,39);
      ship_properties_panel_right.add(panel10);

      autopilotcheckbox = new java.awt.Checkbox("Autopilot");
      autopilotcheckbox.setBounds(5, 5, 77, 23);
      autountillabel = new Label("until Nav");
      autountillabel.setEnabled(false);      
      autolasttextfield = new TextField();
      autolasttextfield.setEditable(false);
      autolasttextfield.setEnabled(false);
      autolasttextfield.setColumns(2);
      autolasttextfield.addActionListener(lSymAction);
      missionnametextfield.addActionListener(lSymAction);
      variablenametextbox.addActionListener(lSymAction);
      
      panel10.add(autopilotcheckbox);
      panel10.add(autountillabel);
      panel10.add(autolasttextfield);

      autopilotcheckbox.setEnabled(false);
      panel11 = new java.awt.Panel();
      panel11.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      panel11.setBounds(0, 273, 135, 39);
      ship_properties_panel_right.add(panel11);
      mustsurvivecheckbox = new java.awt.Checkbox("Must survive");
      mustsurvivecheckbox.setBounds(5, 5, 97, 23);
      panel11.add(mustsurvivecheckbox);
      mustsurvivecheckbox.setEnabled(false);
      panel13 = new java.awt.Panel();
      panel13.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel13.setBounds(0,312,135,39);
      ship_properties_panel_right.add(panel13);
      landcheckbox = new java.awt.Checkbox("Land on this ship");
      //      landcheckbox.setBounds(5,5,125,23);
      panel13.add(landcheckbox);
      landcheckbox.setEnabled(false);
      
      Panel wavecontainger = new Panel();
      wavecontainger.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      java.awt.Panel panel14 = new java.awt.Panel();
//      panel14.setLayout(new G(FlowLayout.LEFT, 5, 5));
      GridLayout grid14 =new GridLayout(1, 2); 
      grid14.setVgap(5);
      grid14.setHgap(5);
      panel14.setLayout(grid14);
      Label shipwavelabel = new Label("Wave");
      panel14.add(shipwavelabel);
      shipwavechoice = new Choice();

      panel14.add(shipwavechoice);
      
                  
      wavecontainger.add(panel14);
      ship_properties_panel_right.add(wavecontainger);
      refuelercheckbox = new Checkbox("Refueler");
      Panel panel15 = new Panel();
      panel15.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      panel15.add(refuelercheckbox);
      ship_properties_panel_right.add(panel15);

      jumpincheckbox = new Checkbox("Jump In");
      Panel panel16 = new Panel();
      panel16.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      panel16.add(jumpincheckbox);
      ship_properties_panel_right.add(panel16);

      
      Panel shipscriptbuttonpanel = new Panel(new FlowLayout(FlowLayout.LEFT, 5, 5));
      
      shipscriptbutton = new Button("Ship Script...");
      shipscriptbutton.addActionListener(lSymAction);
      shipscriptbuttonpanel.add(shipscriptbutton);
      ship_properties_panel_right.add(shipscriptbuttonpanel);
      
      panel2 = new java.awt.Panel();
      panel2.setLayout(new GridLayout(2, 1, 0, 0));
      //      panel2.setBounds(insets().left + 0,insets().top + 0,560,66);
      panel2.setBackground(SystemColor.control);
      add("North", panel2);
      panel9 = new java.awt.Panel();
      panel9.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel9.setBounds(0,0,560,33);
      panel2.add(panel9);
      addshipbutton = new java.awt.Button();
      addshipbutton.setActionCommand("button");
      addshipbutton.setLabel("Add Ship");
      //      addshipbutton.setBounds(5,5,63,23);
      panel9.add(addshipbutton);
      addnavbutton = new java.awt.Button();
      addnavbutton.setActionCommand("button");
      addnavbutton.setLabel("Add Nav Point");
      //      addnavbutton.setBounds(73,5,90,23);
      panel9.add(addnavbutton);
      zoomin = new java.awt.Button();
      zoomin.setActionCommand("button");
      zoomin.setLabel("Zoom In");
      //      zoomin.setBounds(168,5,59,23);
      panel9.add(zoomin);
      zoomout = new java.awt.Button();
      zoomout.setActionCommand("button");
      zoomout.setLabel("Zoom Out");
      //zoomout.setBounds(232,5,68,23);
      panel9.add(zoomout);
      panel12 = new java.awt.Panel();
      panel12.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
      //      panel12.setBounds(0,33,560,33);
      panel2.add(panel12);
      prevnavbutton = new java.awt.Button();
      prevnavbutton.setActionCommand("button");
      prevnavbutton.setLabel("Previous Nav Point");
      //      prevnavbutton.setBounds(5,5,117,23);
      panel12.add(prevnavbutton);
      currentnavtext = new java.awt.Label("text");
      //      currentnavtext.setBounds(127,5,32,23);
      panel12.add(currentnavtext);
      nextnavbutton = new java.awt.Button();
      nextnavbutton.setActionCommand("button");
      nextnavbutton.setLabel("Next Nav Point");
      //nextnavbutton.setBounds(164,5,93,23);
      sectorlabel = new Label("Sector:");
      sectorchoice = new Choice();
      ejectokcheckbox = new Checkbox("Friendly Eject Pickup");
      briefingbutton = new java.awt.Button("");
      briefingbutton.setVisible(false);
      briefingbutton.setLabel("Edit Briefing...");
      panel12.add(nextnavbutton);
      
      asteroidcheckbox = new Checkbox("Asteroids");
      panel12.add(asteroidcheckbox);
      Label numwaveslabel = new Label("Number of waves:");
      panel12.add(numwaveslabel);
      
      numshipwavestextbox = new TextField(2);
      panel12.add(numshipwavestextbox);
      numshipwavestextbox.addActionListener(lSymAction);
      
      navscriptbutton = new Button("Nav Script...");
      navscriptbutton.addActionListener(lSymAction);
      panel12.add(navscriptbutton);
      
      navnamelabel = new Label("Nav Name");
      panel12.add(navnamelabel);
      
      navnametextfield = new TextField(8);
      navnametextfield.addActionListener(lSymAction);
      panel12.add(navnametextfield);
      
      panel9.add(sectorlabel);
      panel9.add(sectorchoice);
      panel9.add(briefingbutton);
      panel9.add(ejectokcheckbox);
      Label missiontitlelabel = new Label("Mission Name");
      panel9.add(missiontitlelabel);
      panel9.add(missionnametextfield);
      
      setTitle("Flight Commander Mission Editor");

      briefingdialog = new BriefingDialog(this, true);
      //}}

      //{{INIT_MENUS
      menuBar1 = new java.awt.MenuBar();
      missionmenu = new java.awt.Menu("Mission");
      openmission = new java.awt.MenuItem("Open...");
      missionmenu.add(openmission);
      savemenu = new MenuItem("Save");
      savemenu.setEnabled(false);
      missionmenu.add(savemenu);
      savemenu.addActionListener(lSymAction);
      saveasmission = new java.awt.MenuItem("Save As...");
      missionmenu.add(saveasmission);
      missionmenu.addSeparator();
      runmissionmenu = new java.awt.MenuItem("Run Flight Commander");  
      runmissionmenu.addActionListener(lSymAction);
      missionmenu.add(runmissionmenu);
      missionmenu.addSeparator();      
      exitmission = new java.awt.MenuItem("Exit");
      missionmenu.add(exitmission);
      menuBar1.add(missionmenu);
      menu1 = new java.awt.Menu("Nav Point");
      addnavpoint = new java.awt.MenuItem("Add");
      menu1.add(addnavpoint);
      removenavpoint = new java.awt.MenuItem("Remove current");
      menu1.add(removenavpoint);
      menuBar1.add(menu1);
      menu2 = new java.awt.Menu("Ship");
      addship = new java.awt.MenuItem("Add");
      menu2.add(addship);
      removeship = new java.awt.MenuItem("Remove current");
      menu2.add(removeship);
      copyship = new MenuItem("Copy ship");
      copyship.addActionListener(lSymAction);
      pasteship = new MenuItem("Paste ship");
      pasteship.addActionListener(lSymAction);
      menu2.add(copyship);
      menu2.add(pasteship);
      menuBar1.add(menu2);
      
      comm_menu = new Menu("Special Comms");
      commbeforemenu = new MenuItem("Comms before current nav...");
      commbeforemenu.addActionListener(lSymAction);
      commaftermenu = new MenuItem("Comms after current nav...");
      commaftermenu.addActionListener(lSymAction);
      comm_menu.add(commbeforemenu);
      comm_menu.add(commaftermenu);
      
      ///////remove special comms menu
      //menuBar1.add(comm_menu);
      
      objectives_menu = new Menu("Objectives");
      editobjectives = new MenuItem("Edit Objectives...");
      editobjectives.addActionListener(lSymAction);
      objectives_menu.add(editobjectives);      
      
      menuBar1.add(objectives_menu);
      
      Menu settingsmenu = new Menu("Settings");
      fcdirectorymenu = new MenuItem("Flight Commander Directory...");
      fcdirectorymenu.addActionListener(lSymAction);
      settingsmenu.add(fcdirectorymenu);
      menuBar1.add(settingsmenu);
      
      setMenuBar(menuBar1);
      //$$ menuBar1.move(0,0);
      //}}

      //{{REGISTER_LISTENERS
      SymWindow aSymWindow = new SymWindow();
      this.addWindowListener(aSymWindow);

      saveasmission.addActionListener(lSymAction);
      openmission.addActionListener(lSymAction);
      exitmission.addActionListener(lSymAction);
      addnavpoint.addActionListener(lSymAction);
      removenavpoint.addActionListener(lSymAction);
      addship.addActionListener(lSymAction);
      removeship.addActionListener(lSymAction);
      prevnavbutton.addActionListener(lSymAction);
      nextnavbutton.addActionListener(lSymAction);
      briefingbutton.addActionListener(lSymAction);
      SymItem lSymItem = new SymItem();
      alignmentchoice.addItemListener(lSymItem);
      shiptypechoice.addItemListener(lSymItem);
      commchoice.addItemListener(lSymItem);
      videochoice.addItemListener(lSymItem);
      playercheckbox.addItemListener(lSymItem);
      ejectokcheckbox.addItemListener(lSymItem);
      xtext.addActionListener(lSymAction);
      ytext.addActionListener(lSymAction);
      ztext.addActionListener(lSymAction);
      pilotname.addActionListener(lSymAction);
      zoomin.addActionListener(lSymAction);
      zoomout.addActionListener(lSymAction);
      autopilotcheckbox.addItemListener(lSymItem);
      mustsurvivecheckbox.addItemListener(lSymItem);
      landcheckbox.addItemListener(lSymItem);
      addshipbutton.addActionListener(lSymAction);
      addnavbutton.addActionListener(lSymAction);
      sectorchoice.addItemListener(lSymItem);
      asteroidcheckbox.addItemListener(lSymItem);
      shipwavechoice.addItemListener(lSymItem);     
      refuelercheckbox.addItemListener(lSymItem);
      jumpincheckbox.addItemListener(lSymItem);
      //}}

      naveditorcanvas = new NavMapEditorCanvas(mission, this);
      tabs.add("Nav Map Editor",naveditorcanvas );
      naveditorcanvas.setStatusbar(statusbartext);
      
      currentnavtext.setText("Nav Point " + mission.getCurrentNavNumber());
      missioncanvas = new MissionCanvas(mission, this);
      missioncanvas.setStatusbar(statusbartext);
      ship_and_properties_panel.add("Center", missioncanvas);
      add("Center",tabs );
      setBackground(SystemColor.control);
      //// nav map editor

      
   }

   private void fillChoice(Choice choice, Vector names)
   {
      int i;
      int size = names.size();

      for (i = 0; i < size; i++)
      {
         choice.add((String) names.elementAt(i));
      }

   }

   /*
    * public synchronized void show() { move(50, 50); super.show(); }
    */

   /*
    * public void addNotify() { // Record the size of the window prior to
    * calling parents addNotify. Dimension d = getSize();
    * 
    * super.addNotify();
    * 
    * if (fComponentsAdjusted) return; // Adjust components according to the
    * insets setSize(insets().left + insets().right + d.width, insets().top +
    * insets().bottom + d.height); Component components[] = getComponents(); for
    * (int i = 0; i < components.length; i++) { Point p =
    * components[i].getLocation(); p.translate(insets().left, insets().top);
    * components[i].setLocation(p); } fComponentsAdjusted = true; }
    */
   // Used for addNotify check.
   boolean fComponentsAdjusted = false;

   //{{DECLARE_CONTROLS
   java.awt.Label sectorlabel;

   java.awt.Choice sectorchoice;

   java.awt.Panel ship_properties_panel_right;

   java.awt.Panel panel3;

   java.awt.Label label2;

   java.awt.Choice shiptypechoice;

   java.awt.Panel panel4;

   java.awt.Label label3;

   java.awt.Choice alignmentchoice;

   java.awt.Panel panel5;

   java.awt.Label label4;

   java.awt.TextField xtext;

   java.awt.Panel panel6;

   java.awt.Label label5;

   java.awt.TextField ytext;

   java.awt.Panel panel7;

   java.awt.Label label6;

   java.awt.TextField ztext;

   java.awt.Panel panel8;

   java.awt.Checkbox playercheckbox;
   java.awt.Checkbox asteroidcheckbox;

   java.awt.Panel panel10;

   java.awt.Checkbox autopilotcheckbox;

   java.awt.Panel panel11;

   java.awt.Checkbox mustsurvivecheckbox;

   java.awt.Panel panel13;

   java.awt.Checkbox landcheckbox;

   java.awt.Panel panel2;

   java.awt.Panel panel9;

   java.awt.Button addshipbutton;

   java.awt.Button addnavbutton;

   java.awt.Button zoomin;

   JSlider slider;
   java.awt.Button zoomout;

   java.awt.Panel panel12;

   java.awt.Button prevnavbutton;

   java.awt.Label currentnavtext;

   java.awt.Button nextnavbutton;

   java.awt.TextField pilotname;
   java.awt.TextField missionnametextfield;

   java.awt.Choice commchoice;

   java.awt.Choice videochoice;

   java.awt.Button briefingbutton;

   BriefingDialog briefingdialog;

   Label autountillabel;
   TextField autolasttextfield;
   TextField variablenametextbox;
   java.awt.Checkbox refuelercheckbox;
   java.awt.Checkbox jumpincheckbox;
   
   Choice shipwavechoice;
   TextField numshipwavestextbox;
   
   //}}
   MissionCanvas missioncanvas;
   java.awt.Checkbox ejectokcheckbox;

   //{{DECLARE_MENUS
   java.awt.MenuBar menuBar1;

   java.awt.Menu missionmenu;

   java.awt.MenuItem saveasmission;
   java.awt.MenuItem savemenu;

   java.awt.MenuItem openmission;

   java.awt.MenuItem exitmission;

   java.awt.Menu menu1;

   java.awt.MenuItem addnavpoint;

   java.awt.MenuItem runmissionmenu;
   java.awt.MenuItem removenavpoint;

   java.awt.Menu menu2;

   java.awt.MenuItem addship;

   java.awt.MenuItem removeship;
   java.awt.MenuItem copyship;
   java.awt.MenuItem pasteship;
   
   java.awt.Menu comm_menu;   
   java.awt.Menu objectives_menu;
   java.awt.MenuItem editobjectives;
   java.awt.MenuItem commbeforemenu;   
   java.awt.MenuItem commaftermenu;
   java.awt.MenuItem fcdirectorymenu; 
   
   Label navnamelabel;
   TextField navnametextfield;

   //}}
   sourceframe source;

   class SymWindow extends java.awt.event.WindowAdapter
   {
      public void windowClosing(java.awt.event.WindowEvent event)
      {
         Object object = event.getSource();
         if (object == MissionEditorFrame.this)
            Frame1_WindowClosing(event);
      }
   }

   void Frame1_WindowClosing(java.awt.event.WindowEvent event)
   {
      //hide(); // hide the Frame
      this.dispose();
      System.exit(0);
   }

   class SymAction implements java.awt.event.ActionListener
   {
      public Vector showCommsDialog(Vector commsin)
      {
         int i;
         CommsDialog d = new CommsDialog(me, true);
         
         DefaultTableModel model = d.getModel();
         model.setNumRows(0);
            

         for(i=0; i < commsin.size(); i++)
         {               
            CommInfo info = (CommInfo) commsin.elementAt(i); 
            model.addRow(info.toObjects() );  
         }
                     
         d.show();
         
         Vector<CommInfo> comms = new Vector<CommInfo>();
         
         for(i=0; i <model.getRowCount(); i++)
         {
            Vector row = (Vector) model.getDataVector().elementAt(i);
            CommInfo info =new CommInfo(row.toArray()); 
           	comms.add(info );              	      
         }
         return comms;
         
      }
      
      private void saveMission(String filename)
      {
         try
         {
            mission.setSector(sectorchoice.getSelectedItem());
            mission.save(filename);
            lastfilename = filename;
            savemenu.setEnabled(true);
         }
         catch (Exception e)
         {
//            MessageDialog dialog = new MessageDialog(me, true);
//            dialog.setText("Could not save file");
//            dialog.setVisible(true);
        	  JOptionPane.showMessageDialog(me, "Could not save file");
         }

      }
      
      public void actionPerformed(java.awt.event.ActionEvent event)
      {
         Object object = event.getSource();
         Ship currentship = mission.getCurrentNav().getCurrentShip();

         if (object == saveasmission)
         {
        	MissionValidStatus status =mission.isValid(); 
            if (status.valid)
            {
               java.awt.FileDialog fd = new FileDialog(me);
               fd.setTitle("Save a mission.xml file");
               fd.setMode(java.awt.FileDialog.SAVE);
               Preferences prefs = Preferences.userNodeForPackage(MissionEditorFrame.class);
               String directory = prefs.get("FlightCommanderDirectory", "");
               fd.setDirectory(directory);
               fd.show();
               String file = fd.getFile();
               if (file != null)
               {                  
                  String filename = fd.getDirectory() + fd.getFile();
                  saveMission(filename);
               }

            }
            else
            {
               JOptionPane.showMessageDialog(me, status.reason);
            }
         }

         else if (object == savemenu)
         {
            if(lastfilename != null)
            {
               saveMission(lastfilename);
            }
         }         
         else if (object == openmission)
         {
            java.awt.FileDialog fd = new FileDialog(me);
            fd.setTitle("Open a mission.xml file");
            fd.setMode(java.awt.FileDialog.LOAD);
            Preferences prefs = Preferences.userNodeForPackage(MissionEditorFrame.class);
            String directory = prefs.get("FlightCommanderDirectory", "");
            fd.setDirectory(directory);            
            fd.show();
            String file = fd.getFile();
            if (file != null)
            {
               String filename = fd.getDirectory() + fd.getFile();


               mission.setBriefing(null);
               try
               {
                  mission.load(filename);
                  lastfilename = filename;                  
                  lastfilename = filename;
                  savemenu.setEnabled(true);
               }
               catch (Throwable e)
               {
            	  e.printStackTrace();
                  MessageDialog dialog = new MessageDialog(me, true);
                  dialog.setText("Could not load file");
                  dialog.setVisible(true);                 
               }
               missionnametextfield.setText(mission.getName());
               updateNavPoint();
               briefingdialog.setText(mission.getBriefing());
               sectorchoice.select(mission.getSector());
               ejectokcheckbox.setState(mission.getFriendlyEjectPickup());              
            }
         }
         else if (object == exitmission)
         {
            Frame1_WindowClosing(null);
         }
         else if(object == copyship)
         {
            try
            {
            copiedship = (Ship) currentship.clone();
            }
            catch(CloneNotSupportedException e)
            {
               e.printStackTrace();
            }
         }
         else if(object == pasteship)
         {
            try
            {
            copiedship = (Ship) currentship.clone();
            }
            catch(CloneNotSupportedException e)
            {
               e.printStackTrace();
            }            
            missioncanvas.setPasteMode();
         }
         else if (object == addnavpoint)
         {
         	tabs.setSelectedIndex(1); // the nav editor
        	naveditorcanvas.setCreateMode();
         }
         else if (object == removenavpoint)
         {
            mission.removeCurrentNav();
            updateNavPoint();
         }
         else if (object == briefingbutton)
         {
            briefingdialog.show();
            mission.setBriefing(briefingdialog.getText());

         }
         else if (object == addship)
         {
            missioncanvas.setCreateMode();
         }
         else if (object == removeship)
         {
            NavPoint nav = mission.getCurrentNav();
            if (nav != null)
            {
               nav.removeCurrentShip();
            }
            missioncanvas.paint(missioncanvas.getGraphics());
            updateNavPoint();
         }
         else if (object == prevnavbutton)
         {
            mission.prevNav();
            updateNavPoint();
         }
         else if (object == nextnavbutton)
         {
            mission.nextNav();
            updateNavPoint();
         }
         else if(object == navnametextfield)
         {
             NavPoint nav = mission.getCurrentNav();
             
             nav.setName( navnametextfield.getText());
             naveditorcanvas.repaint();
         }
         else if (object == xtext)
         {
            try
            {
               float newx = Float.valueOf(xtext.getText()).floatValue();
               currentship.setX(newx);
               updateNavPoint();
            }
            catch (NumberFormatException e)
            {

            }

         }
         else if(object == variablenametextbox)
         {
        	 currentship.setVariablename(variablenametextbox.getText());
         }
         else if (object == ytext)
         {
            try
            {
               float newy = Float.valueOf(ytext.getText()).floatValue();
               currentship.setY(newy);
               updateNavPoint();
            }
            catch (NumberFormatException e)
            {

            }

         }
         else if (object == ztext)
         {
            try
            {
               float newz = Float.valueOf(ztext.getText()).floatValue();
               currentship.setZ(newz);
               updateNavPoint();
            }
            catch (NumberFormatException e)
            {

            }

         }
         else if(object == autolasttextfield)
         {
            String newtext = autolasttextfield.getText();
            Integer newint;
            try
            {
              newint = new Integer(newtext);
              int newinti = newint.intValue();
              if(newinti < 0 || newinti > mission.getLastNavNumber() ||
                    newinti <= mission.getCurrentNavNumber())
              {
                 throw new NumberFormatException();
              }
              currentship.setLastAutopilotNav(newinti);
            }
            catch(NumberFormatException ne)
            {
              newint = new Integer(-1);
              autolasttextfield.setText("");
              currentship.setLastAutopilotNav(-1);              
            }
         }
         else if (object == pilotname)
         {
            currentship.setName(pilotname.getText());

         }
         else if (object == zoomin)
         {
            missioncanvas.zoomIn();
            missioncanvas.paint(missioncanvas.getGraphics());
         }
         else if (object == zoomout)
         {
            missioncanvas.zoomOut();
            missioncanvas.paint(missioncanvas.getGraphics());
         }
         else if (object == addshipbutton)
         {
            missioncanvas.setCreateMode();
         }
         else if(object == shipscriptbutton)
         {        	 
        	 if(currentship != null)
        	 {
        		 ScriptPickDialog dialog = new ScriptPickDialog(me, true);
        		 dialog.setScript(currentship.getScript());
        		 dialog.setTitle("Ship Script Functions");
        		 dialog.show();
        		 currentship.setScript(dialog.getScript());
        	 }
         }
         else if(object == navscriptbutton)
         {        	 
        	 NavPoint nav = mission.getCurrentNav();
        	 ScriptPickDialog dialog = new ScriptPickDialog(me, true);
        	 dialog.setScript(nav.getScript());
        	 dialog.setTitle("Nav Script Functions");
        	 dialog.show();
        	 nav.setScript(dialog.getScript());
         }         
         else if (object == addnavbutton)
         {
            //mission.addNavPoint();
        	tabs.setSelectedIndex(1); // the nav editor
        	naveditorcanvas.setCreateMode();
        	 
            updateNavPoint();
         }
         else if(object == commbeforemenu)
         {              
            Vector comms = mission.getCurrentNav().getBeforeComms(); 
            comms = showCommsDialog(comms);
            mission.getCurrentNav().setBeforeComms(comms);

         }
         else if(object == commaftermenu)
         {
            Vector comms = mission.getCurrentNav().getAfterComms(); 
            comms = showCommsDialog(comms);
            mission.getCurrentNav().setAfterComms(comms);
            
         }
         else if(object == editobjectives)
         {
        	 ObjectivesDialog objectivesd = new ObjectivesDialog(me, true);
        	 objectivesd.setDataVector( mission.getObjectives());        	 
        	 objectivesd.show();
        	 mission.setObjectives( objectivesd.getDataVector());
         }
         else if(object == fcdirectorymenu)
         {
            JFileChooser filechooser = new JFileChooser();
            filechooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            filechooser.showOpenDialog(me);
            File directory = filechooser.getSelectedFile();
            if(directory != null)
            {
               Preferences prefs = Preferences.userNodeForPackage(MissionEditorFrame.class);
               prefs.put("FlightCommanderDirectory", directory.getAbsolutePath());
            }
         }
         else if(object == runmissionmenu)
         {
            Preferences prefs = Preferences.userNodeForPackage(MissionEditorFrame.class);
            String directory = prefs.get("FlightCommanderDirectory", "");
            if(directory.equals(""))
            {
               JOptionPane.showMessageDialog(me, "Cannot find Flight Commander.");
            }
            else
            {
               try
               {
                 Runtime.getRuntime().exec(directory + File.separator + "FlightCommander.exe", null, new File(directory));
               }
               catch (Exception e) {
                  e.printStackTrace();
                  JOptionPane.showMessageDialog(me, "Cannot find Flight Commander.");                 
               }
            }
         }
         else if(object == missionnametextfield)
         {
        	 mission.setName(missionnametextfield.getText());
         }
         else if(object == numshipwavestextbox)
         {
        	 try
        	 {
        	   int value = Integer.parseInt(numshipwavestextbox.getText());
        	   if(value < 1)
        	   {
          		 numshipwavestextbox.setText("" + mission.getCurrentNav().getNumWaves());        		   
        	   }
        	   else
        	   {
        	     mission.getCurrentNav().setNumWaves(value);    
        	     updateNavPoint();
        	   }
        	   
        	 }
        	 catch (NumberFormatException e) 
        	 {
        		 numshipwavestextbox.setText("" + mission.getCurrentNav().getNumWaves());
			 }
         }
      }
   }

   public void updateNavPoint()
   {
      int i;	   
	   
      NavPoint currentnav = mission.getCurrentNav();

      currentnavtext.setText("Nav Point " + mission.getCurrentNavNumber());
      missioncanvas.paint(missioncanvas.getGraphics());
      naveditorcanvas.repaint();
      if (currentnav.getNumShips() == 0)
      {
         setNavEditable(false);
      }
      else
      {         
         setNavEditable(true);
      }
      asteroidcheckbox.setState(currentnav.isHasAsteroids());
      numshipwavestextbox.setText(((Integer)currentnav.getNumWaves()).toString());
      shipwavechoice.removeAll();      
      for(i=0; i < currentnav.getNumWaves(); i++)
      {
    	  shipwavechoice.add("" + i);
      }      
      onShipSelectionChange();
      navnametextfield.setText(currentnav.getName());
   }

   public String getCurrentShipChoice()
   {
      return shiptypechoice.getSelectedItem();
   }
   public Ship getPasteShip()
   {
      return copiedship;
   }

   
   public void onShipSelectionChange()
   {
      Ship currentship = mission.getCurrentNav().getCurrentShip();
      if (currentship != null)
      {
         if (currentship.isEnemy())
         {
            mustsurvivecheckbox.setState(false);
            mustsurvivecheckbox.setEnabled(false);
         }
         else
         {
            mustsurvivecheckbox.setEnabled(true);
            mustsurvivecheckbox.setState(currentship.getMustSurvive());
         }
         if (currentship.isEnemy()|| currentship.isNeutral() 
               || mission.getCurrentNavNumber() == mission.getLastNavNumber())
         {
            autopilotcheckbox.setState(false);
            autopilotcheckbox.setEnabled(false);
            autountillabel.setEnabled(false);
            autolasttextfield.setEditable(false);
            autolasttextfield.setEnabled(false);
            autolasttextfield.setText("");            
         }
         else if (currentship.isPlayer())
         {
            autopilotcheckbox.setEnabled(false);
            autopilotcheckbox.setState(true);
            autountillabel.setEnabled(false);
            autolasttextfield.setEditable(false);
            autolasttextfield.setEnabled(false);
            autolasttextfield.setText("");
            
         }
         else
         {
            autopilotcheckbox.setEnabled(true);
            autopilotcheckbox.setState(currentship.getAutopilot());
            autountillabel.setEnabled(currentship.getAutopilot());
            autolasttextfield.setEditable(currentship.getAutopilot());
            autolasttextfield.setEnabled(currentship.getAutopilot());
            if(currentship.getAutopilot())
            {             
              int mylast = currentship.getLastAutopilotNav();
              if(mylast != -1)
              {
                autolasttextfield.setText("" + mylast);  
              }
              else
              {
                 autolasttextfield.setText("");                 
              }
            }
            else
            {
               autolasttextfield.setText("");                              
            }
         }
         xtext.setText(Float.toString(currentship.getX()));
         ytext.setText(Float.toString(currentship.getY()));
         ztext.setText(Float.toString(currentship.getZ()));
         alignmentchoice.select(currentship.getAlignment());
         shiptypechoice.select(currentship.getType());

         if (currentship.isFriend()
               && mission.getCurrentNavNumber() == mission.getLastNavNumber()
               && (!currentship.isPlayer()))
         {
            landcheckbox.setState(currentship.getLand());
            landcheckbox.setEnabled(true);
         }
         else
         {
            landcheckbox.setState(false);
            landcheckbox.setEnabled(false);
         }
         if (mission.getCurrentNavNumber() == 0 && currentship.isFriend())
         {
            playercheckbox.setEnabled(true);
            playercheckbox.setState(currentship.isPlayer());
         }
         else
         {
            playercheckbox.setState(false);
            playercheckbox.setEnabled(false);
         }
                  
         commchoice.setEnabled(true);
         videochoice.setEnabled(true);
         commchoice.select(currentship.getComm());
         videochoice.select(currentship.getVideo());
         pilotname.setEnabled(true);
         pilotname.setText(currentship.getName());
         shipwavechoice.setEnabled(true);         
         shipwavechoice.select(""+ currentship.getWave());
         refuelercheckbox.setEnabled(true);
         refuelercheckbox.setState(currentship.isRefueler());
         jumpincheckbox.setEnabled(true);
         jumpincheckbox.setState(currentship.isJumpingIn());
         
         shipscriptbutton.setEnabled(true);
         variablenametextbox.setEnabled(true);
         variablenametextbox.setText(currentship.getVariablename());
         slider.setEnabled(true);
         slider.setValue((int) currentship.getRy());
      }
      else
      // current ship is null
      {
    	  variablenametextbox.setEnabled(false);
    	  variablenametextbox.setText("");
     	  shipscriptbutton.setEnabled(false);    	  
         mustsurvivecheckbox.setState(false);
         mustsurvivecheckbox.setEnabled(false);
         autopilotcheckbox.setState(false);
         autopilotcheckbox.setEnabled(false);
         playercheckbox.setState(false);
         playercheckbox.setEnabled(false);
         landcheckbox.setState(false);
         landcheckbox.setEnabled(false);
         commchoice.setEnabled(false);
         videochoice.setEnabled(false);
         pilotname.setEnabled(false);
         autountillabel.setEnabled(false);
         autolasttextfield.setEnabled(false);
         autolasttextfield.setEditable(false);
         autolasttextfield.setText("");
         shipwavechoice.setEnabled(false);
         refuelercheckbox.setState(false);
         refuelercheckbox.setEnabled(false);
         jumpincheckbox.setState(false);
         jumpincheckbox.setEnabled(false);
         slider.setEnabled(false);
         slider.setValue(0);
      }
   }

   class SymItem implements java.awt.event.ItemListener
   {

      public void itemStateChanged(java.awt.event.ItemEvent event)
      {
         Object object = event.getSource();
         Ship currentship = mission.getCurrentNav().getCurrentShip();

         if (object == alignmentchoice)
         {

            if (currentship != null)
            {
               currentship.setAlignment(alignmentchoice.getSelectedItem());
               currentship.setPlayer(false);
               currentship.setMustSurvive(false);
               currentship.setAutopilot(false);
               currentship.setLand(false);
               missioncanvas.paint(missioncanvas.getGraphics());
               onShipSelectionChange();
            }

         }
         else if(object == shipwavechoice)
         {
        	if (currentship != null)
        	{
        		currentship.setWave(new Integer(shipwavechoice.getSelectedItem()));
        	}
        	 
         }
         else if (object == sectorchoice)
         {
            mission.setSector(sectorchoice.getSelectedItem());

         }
         else if (object == shiptypechoice)
         {

            if (currentship != null)
            {
               currentship.setType(shiptypechoice.getSelectedItem());
            }
         }
         else if (object == commchoice)
         {
            if (currentship != null)
            {
               currentship.setComm(commchoice.getSelectedItem());
            }
         }
         else if (object == videochoice)
         {
            if (currentship != null)
            {
               currentship.setVideo(videochoice.getSelectedItem());
            }
         }

         else if (object == playercheckbox)
         {

            if (!currentship.getAlignment().equals("friend")
                  || currentship.getLand())
            {
               playercheckbox.setState(false);
               return;

            }
            if (playercheckbox.getState())
            {
               mission.getCurrentNav().setCurrentShipAsPlayer();
               currentship.setAutopilot(true);
            }
            else
            {

               currentship.setPlayer(false);
            }
            onShipSelectionChange();
         }
         else if (object == autopilotcheckbox)
         {
            currentship.setAutopilot(autopilotcheckbox.getState());
            autountillabel.setEnabled(autopilotcheckbox.getState());
            autolasttextfield.setEditable(autopilotcheckbox.getState());
            autolasttextfield.setEnabled(autopilotcheckbox.getState());
            if(!autopilotcheckbox.getState())
            {
               autolasttextfield.setText("");
            }
         }
         else if (object == mustsurvivecheckbox)
         {
            currentship.setMustSurvive(mustsurvivecheckbox.getState());
         }
         else if(object == ejectokcheckbox)
         {
           mission.setFriendlyEjectPickup(ejectokcheckbox.getState());            
         }
         else if(object == asteroidcheckbox)
         {
            mission.getCurrentNav().setHasAsteroids(asteroidcheckbox.getState());
         }
         else if(object == refuelercheckbox)
         {
        	currentship.setRefueler(refuelercheckbox.getState());
         }
         else if(object == jumpincheckbox)
         {
        	 currentship.setJumpingIn(jumpincheckbox.getState());
         }
         else if (object == landcheckbox)
         {
            if (landcheckbox.getState())
            {
               if (!currentship.isPlayer())
               {
                  mission.getCurrentNav().setCurrentShipAsLand();
               }
               else
               {
                  currentship.setLand(false);
                  landcheckbox.setState(false);
               }
            }
            else
            {

               currentship.setLand(false);
            }
         }
      }
   }

   public void onShipAdded()
   {
      setNavEditable(true);
   }

   private void setNavEditable(boolean editable)
   {
      shiptypechoice.setEnabled(editable);
      alignmentchoice.setEnabled(editable);
      xtext.setEnabled(editable);
      ytext.setEnabled(editable);
      ztext.setEnabled(editable);
      pilotname.setEnabled(editable);
   }

   public Vector<String> getFromStream(String filename)
   {
      Vector<String> v = new Vector<String>();
      InputStream is = null;
      try
      {

         String current;

         is = getClass().getResourceAsStream(filename);
         BufferedReader br = new BufferedReader(new InputStreamReader(is));
         current = br.readLine();
         while (current != null)
         {
            current = current.trim();
            v.add(current);
            current = br.readLine();
         }

      }
      catch (IOException io)
      {
      }
      finally
      {
         try
         {
            if (is != null)
               is.close();
         }
         catch (IOException ie)
         {
         }
      }
      return v;

   }

   public static void main(String[] args)
   {
      try
      {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      }
      catch (ClassNotFoundException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (InstantiationException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (IllegalAccessException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (UnsupportedLookAndFeelException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }

      MissionEditorFrame frame = new MissionEditorFrame();

      frame.pack();
      frame.setVisible(true);
      frame.repaint();
   }

}