import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragSource;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;


public class NavMapEditorCanvas extends MissionCanvas {
	
	public NavMapEditorCanvas(Mission newmission, MissionEditorFrame newframe) {
		super(newmission, newframe);
		// TODO Auto-generated constructor stub
		setFudgefactor(10000.0f);
	}
	public void paint(Graphics g)
	{
	      int i;
	      Dimension mysize = getSize();
	      g.setColor(Color.black);
	      g.fillRect(0, 0, mysize.width, mysize.height);
	      
	      
	      Color darkgreen = new Color(0.0f, .5f, 0.0f);
		   Color fcgreen = new Color(0.1f, .86f, 0.4f);
	      renderGrid(g, 2000.0f, darkgreen);
	      
	      // center
	      renderGrid(g, 200000.0f, Color.YELLOW);	
	      
	      // render navs
	      float scale = getScale();
	      float x, y;
	      int intx, inty;
	      int centerx = mysize.width / 2;
	      int centery = mysize.height / 2;
	      

	      for(i=0; i < mission.getLastNavNumber() + 1; i++)
	      {
	    	  NavPoint nav = mission.getNavAt(i);
	    	  if(nav == mission.getCurrentNav() )
	    	  {
	    	      g.setColor(Color.WHITE);	    		  
	    	  }
	    	  else
	    	  {
	    		  g.setColor(fcgreen);	    		  	    		  
	    	  }
	    	  int rad = 20;
	    	  x = nav.getX();
	    	  y = nav.getZ();
	    	  
	    	  
	    	  
	          intx = centerx + (int) (x * 1 / scale);
	          inty = centery + (int) (y * 1 / scale);
	    	  
	    	  g.drawOval(intx - rad, (int)inty - rad, 2 * rad, 2 * rad);
	    	  
	    	  String navname = nav.getName();
	    	  Rectangle2D bounds = g.getFontMetrics().getStringBounds(navname, g);
	    	  double xoffset = bounds.getWidth() / 2;
	    	  g.drawString(navname, intx - (int)xoffset, inty + rad + (int) bounds.getHeight() );
	      }
	      
	}
	
	@Override protected void handleDrop(Point location)
	{
	      int centerx, centery;
	      int min;
	   
	      Dimension mysize = getSize();
	      centerx = mysize.width / 2;
	      centery = mysize.height / 2;
	      if (mysize.width < mysize.height)
	         min = mysize.width;
	      else
	         min = mysize.height;
	      	      
	      float scale = zoomfactor * fudgefactor / min;
	      NavPoint nav = mission.getCurrentNav();

	      nav.setX(((float) (location.getX() - centerx)) * scale);
	      nav.setZ(((float) (location.getY() - centery)) * scale);	   	   
		
	}
	
	@Override   public void mousePressed(MouseEvent e)
	   {
	      int centerx, centery;

	      Dimension mysize = getSize();
	      centerx = mysize.width / 2;
	      centery = mysize.height / 2;

	      float min;

	      if (mysize.width < mysize.height)
	         min = mysize.width;
	      else
	         min = mysize.height;

	      float scale = zoomfactor * fudgefactor / min;

	      if (selectmode == SelectMode.SELECT)
	      {
	          mission.setCurrentNav(
	                  ((float) (e.getX() - centerx)) * scale,
	                  ((float) (e.getY() - centery)) * scale, scale);
	      }
	      else if(selectmode == SelectMode.PASTE)
	      {
/*	    	  
	         Ship pasteship = frame.getPasteShip();
	         if(pasteship != null)
	         {
	            mission.getCurrentNav().addShip(
	                  ((float) (e.getX() - centerx)) * scale,
	                  ((float) (e.getY() - centery)) * scale,
	                  pasteship);
	            
	         }
*/	         
	      }
	      else
	      {
		     mission.addNavPoint();	    	  
		      NavPoint nav = mission.getCurrentNav();

		      nav.setX(((float) (e.getX() - centerx)) * scale);
		      nav.setZ(((float) (e.getY() - centery)) * scale);	   	   
	         frame.onShipAdded();
	      }
	      selectmode = SelectMode.SELECT;
	      setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	      paint(getGraphics());
	      frame.updateNavPoint();

	   }
	   @Override public void dragGestureRecognized(DragGestureEvent e)
	   {
	         e.startDrag(DragSource.DefaultCopyDrop, new ShipTranferable(), this);
	   }

}
