import java.util.Vector;
import java.lang.Math;

public class NavPoint extends java.lang.Object
{
    private Vector<Ship> ships;
    private int currentship;
    private boolean hasAsteroids;
    private Vector afterComms;
    private Vector beforeComms;
    private int numWaves;
    private Script script;
    private String name;
    private float x, y, z;

    public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public NavPoint()
    {
      ships = new Vector<Ship>();
      currentship = -1;
      hasAsteroids = false;
      beforeComms = new Vector();
      afterComms = new Vector();
      numWaves = 1;
      script = new Script();
      name = "";
    }

    public Ship getCurrentShip()
    {
       if(ships.size() == 0)
         return null;
       else
       {
         return (Ship) ships.elementAt(currentship);
       }
    }

    public void addShip(float x, float z, String name)
    {
        ships.addElement(new Ship(x, 0.0f, z, name));
        currentship = ships.size() - 1;
    }

    public void addShip(float x, float z, Ship newship)
    {
        newship.setX(x);
        newship.setZ(z);
        ships.addElement(newship);
        currentship = ships.size() - 1;
    }

    public void addShip(Ship newship)
    {
      ships.addElement(newship);
      currentship = ships.size() - 1;
    }

    public void removeCurrentShip()
    {
      if(ships.size() != 0)
         ships.removeElementAt(currentship);
      currentship = 0;
    }
    public void setCurrentShip(float x, float z, float scale)
    {
        int i;
        Ship currentshipobject;
        float delta = 8.0f * scale;
       
        
        for(i=0; i < ships.size(); i++)
        {
            currentshipobject = (Ship) ships.elementAt(i);
            if(Math.abs(currentshipobject.getX() - x) < delta
             && Math.abs(currentshipobject.getZ() - z) < delta)
            {
                currentship = i;
                return;

            }
        }
    }
    public int getNumShips()
    {
      return ships.size();
    }
    public Ship getShip(int index)
    {
     return (Ship) ships.elementAt(index);
    }
    public void setCurrentShipAsPlayer()
    {
        int i;
        Ship currentshipobject;
        for(i=0; i < ships.size(); i++)
        {
            currentshipobject = (Ship) ships.elementAt(i);
            if(i == currentship)
            {
              currentshipobject.setPlayer(true);
            }
            else
            {
              currentshipobject.setPlayer(false);
            }
        }
    }

    void setCurrentShipAsLand()
    {
        int i;
        Ship currentshipobject;
        for(i=0; i < ships.size(); i++)
        {
            currentshipobject = (Ship) ships.elementAt(i);
            if(i == currentship)
            {
              currentshipobject.setLand(true);
            }
            else
            {
              currentshipobject.setLand(false);
            }
        }
    }
   public boolean isHasAsteroids()
   {
      return hasAsteroids;
   }
   public void setHasAsteroids(boolean hasAsteroids)
   {
      this.hasAsteroids = hasAsteroids;
   }
   public Vector getAfterComms()
   {
      return afterComms;
   }
   public void setAfterComms(Vector afterComms)
   {
      this.afterComms = afterComms;
   }
   public Vector getBeforeComms()
   {
      return beforeComms;
   }
   public void setBeforeComms(Vector beforeComms)
   {
      this.beforeComms = beforeComms;
   }

   public int getNumWaves() 
   {
	return numWaves;
   }

   public void setNumWaves(int numWaves) 
   {
	int i;
	this.numWaves = numWaves;
	for(i=0; i < ships.size(); i++)
	{
		Ship s = ships.elementAt(i);
		s.setWave(Math.min(s.getWave(), numWaves -1));
		
	}
	
	
   }

public Script getScript() {
	return script;
}

public void setScript(Script script) {
	this.script = script;
}

public float getX() {
	return x;
}

public void setX(float x) {
	this.x = x;
}

public float getY() {
	return y;
}

public void setY(float y) {
	this.y = y;
}

public float getZ() {
	return z;
}

public void setZ(float z) {
	this.z = z;
}
}