public class Ship extends java.lang.Object implements Cloneable
{
    private String type;
    private String alignment;
    private String name;
    private String comm;
    private String video;
    private float x, y, z;
    private float rx, ry, rz;
    private boolean player;
    private boolean autopilot;
    private boolean land;
    private boolean mustsurvive;
    private int lastautopilotnav;
    private int wave;
    private boolean refueler;
    private Script script;
    private String variablename;
    private boolean jumpingIn;

    public Object clone() throws CloneNotSupportedException
    {
       Ship newship = new Ship();
       
       newship.type = type;
       newship.alignment = alignment;
       newship.name = name;
       newship.comm = comm;
       newship.video = video;
       newship.player = false;
       newship.autopilot = autopilot;
       newship.land = land;
       newship.mustsurvive = mustsurvive;
       newship.lastautopilotnav = lastautopilotnav;
       newship.wave = wave;
       newship.refueler = refueler;
       newship.script = new Script(script);
       newship.variablename = variablename;
       return newship;
       
    }
    public Ship()
    {
       alignment = "friend";
       type = new String();
       player = false;
       land = false;
       mustsurvive = false;
       autopilot = true;
       name = new String();
       comm = new String("");
       video = new String("");
       lastautopilotnav = -1;
       refueler = false;
       wave = 0;
       variablename = "";
       script = new Script();
       rx = ry = rz = 0;
    }

    public Ship(float newx, float newy, float newz, String name)
    {
       x = newx;
       y = newy;
       z = newz;
       alignment = "friend";
       type = name;
       player = false;
       land = false;
       mustsurvive = false;
       autopilot = false;
       comm = new String("");
       video = new String("");
       lastautopilotnav = -1;
       wave = 0;
       refueler = false;
       script = new Script();
       variablename = "";
       rx = ry = rz = 0;
       this.name= "";
    }

    public void setAutopilot(boolean value)
    {
      autopilot =  value;
    }

    public boolean getAutopilot()
    {
     return autopilot;
    }

    public void setLand(boolean value)
    {
     land = value;
    }

    public boolean getLand()
    {
     return land;
    }

    public boolean getMustSurvive()
    {
     return mustsurvive;
    }

    public void setMustSurvive(boolean value)
    {
     mustsurvive = value;
    }
    public void setAlignment(String newalignment)
    {
      alignment = newalignment;
    }

    public float getX()
    {
     return x;
    }

    public float getY()
    {
        return y;
    }

    public float getZ()
    {
        return z;
    }

    public void setX(float newx)
    {
      x = newx   ;
    }

    public void setY(float newy)
    {
        y = newy;
    }

    public void setZ(float newz)
    {
        z = newz;
    }


    public String getAlignment()
    {
      return alignment;
    }

    public String getType()
    {
     return type;
    }
    public void setType(String shiptype)
    {
     type = shiptype;
    }
    public void setPlayer(boolean newplayer)
    {
     player = newplayer;
     if(player)
     {
    	 wave = 0;
     }
    }
    public boolean isPlayer()
    {
     return player;
    }

    public boolean isEnemy()
    {
     return alignment.equals("enemy");
    }
    
    public boolean isNeutral()
    {
     return alignment.equals("neutral");
    }
    
    public boolean isFriend()
    {
       return alignment.equals("friend");
    }
    
    public void setName(String newname)
    {
     name = newname;
    }

    public String getName()
    {
      return name;
    }
    public void setComm(String newname)
    {
     comm = newname;
    }

    public String getComm()
    {
      return comm;
    }

   public String getVideo()
   {
      return video;
   }
   public void setVideo(String video)
   {
      this.video = video;
   }
   
   public int getLastAutopilotNav()
   {
      if(autopilot)
      {
         return lastautopilotnav;
      }
      return -1;
   }
   public void setLastAutopilotNav(int lastautopilotnav)
   {
      this.lastautopilotnav = lastautopilotnav;
   }
   public int getWave() 
   {
	return wave;
   }
   
   public void setWave(int wave) 
   {
	if(! player)
	{
	this.wave = wave;
	}
   }
   
public boolean isRefueler() 
{
	return refueler;
}
public void setRefueler(boolean refueler) 
{
	this.refueler = refueler;
}
public Script getScript() {
	return script;
}
public void setScript(Script script) {
	this.script = script;
}
public String getVariablename() {
	return variablename;
}
public void setVariablename(String variablename) {
	this.variablename = variablename;
}
public float getRy() {
	return ry;
}
public void setRy(float ry) {
	this.ry = ry;
}
public float getRx() {
	return rx;
}
public void setRx(float rx) {
	this.rx = rx;
}
public float getRz() {
	return rz;
}
public void setRz(float rz) {
	this.rz = rz;
}
public void setJumpingIn(boolean newjumpingIn) {
	jumpingIn = newjumpingIn;
}
public boolean isJumpingIn() {
	return jumpingIn;
}

public boolean isScriptValid()
{
  if(!script.isValid())
  {
	  return true; // there is no script
  }
  // script exists
  return variablename != null && variablename.length() != 0; 	
}
}